(function (global, factory) {
	typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('react')) :
	typeof define === 'function' && define.amd ? define(['exports', 'react'], factory) :
	(factory((global.ReactManagedDraggable = {}),global.React));
}(this, (function (exports,react) { 'use strict';

	react = react && react.hasOwnProperty('default') ? react['default'] : react;

	var commonjsGlobal = typeof window !== 'undefined' ? window : typeof global !== 'undefined' ? global : typeof self !== 'undefined' ? self : {};

	function unwrapExports (x) {
		return x && x.__esModule && Object.prototype.hasOwnProperty.call(x, 'default') ? x['default'] : x;
	}

	function createCommonjsModule(fn, module) {
		return module = { exports: {} }, fn(module, module.exports), module.exports;
	}

	var es5 = createCommonjsModule(function (module, exports) {
	var __extends = (commonjsGlobal && commonjsGlobal.__extends) || (function () {
	    var extendStatics = function (d, b) {
	        extendStatics = Object.setPrototypeOf ||
	            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
	            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
	        return extendStatics(d, b);
	    };
	    return function (d, b) {
	        extendStatics(d, b);
	        function __() { this.constructor = d; }
	        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
	    };
	})();
	var __assign = (commonjsGlobal && commonjsGlobal.__assign) || function () {
	    __assign = Object.assign || function(t) {
	        for (var s, i = 1, n = arguments.length; i < n; i++) {
	            s = arguments[i];
	            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
	                t[p] = s[p];
	        }
	        return t;
	    };
	    return __assign.apply(this, arguments);
	};
	var __rest = (commonjsGlobal && commonjsGlobal.__rest) || function (s, e) {
	    var t = {};
	    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
	        t[p] = s[p];
	    if (s != null && typeof Object.getOwnPropertySymbols === "function")
	        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
	            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
	                t[p[i]] = s[p[i]];
	        }
	    return t;
	};
	Object.defineProperty(exports, "__esModule", { value: true });

	if (!window['react-managed-draggable-style-injected']) {
	    window['react-managed-draggable-style-injected'] = true;
	    var styleElement = document.createElement('style');
	    styleElement.innerHTML = '.react-managed-draggable-unselectable { user-select: none; }';
	    document.body.appendChild(styleElement);
	}
	var rafThrottle = function (callback) {
	    var requestId;
	    var later = function (context, args) { return function () {
	        requestId = null;
	        callback.apply(context, args);
	    }; };
	    var throttled = function () {
	        var args = [];
	        for (var _i = 0; _i < arguments.length; _i++) {
	            args[_i] = arguments[_i];
	        }
	        if ((requestId === null) || (requestId === undefined)) {
	            requestId = window.requestAnimationFrame(later(this, args));
	        }
	    };
	    throttled.cancel = function () { return requestId !== null && window.cancelAnimationFrame(requestId); };
	    return throttled;
	};
	function manhattanDistance(p1, p2) {
	    return Math.abs(p1.x - p2.x) + Math.abs(p1.y - p2.y);
	}
	function getPosition(event) {
	    if ('touches' in event) {
	        if (event.touches.length >= 1) {
	            return { x: event.touches[0].clientX, y: event.touches[0].clientY };
	        }
	        else {
	            return { x: 0, y: 0 };
	        }
	    }
	    else {
	        return { x: event.clientX, y: event.clientY };
	    }
	}
	exports.getPosition = getPosition;
	var ElementDraggable = /** @class */ (function () {
	    function ElementDraggable(element, options, immediate) {
	        var _this = this;
	        this.down = false;
	        this.dragging = false;
	        this.start = { x: 0, y: 0 };
	        this.current = { x: 0, y: 0 };
	        this.handleDown = function (event) {
	            if (!_this.down && !_this.dragging) {
	                _this.down = true;
	                document.addEventListener('mousemove', _this.handleMove);
	                document.addEventListener('touchmove', _this.handleMove);
	                document.addEventListener('mouseup', _this.handleUp);
	                document.addEventListener('touchend', _this.handleUp);
	                document.body.classList.add('react-managed-draggable-unselectable');
	                _this.current = _this.start = getPosition(event);
	                if (_this.getThreshold() <= 0) {
	                    _this.dragging = true;
	                    if (_this.options.onDragStart) {
	                        _this.options.onDragStart(event, _this.generateDragInformation(_this.current));
	                    }
	                    // event.stopPropagation();
	                    event.preventDefault();
	                }
	            }
	        };
	        this.handleMove = rafThrottle(function (event) {
	            if (_this.down || _this.dragging) {
	                var last = _this.current;
	                _this.current = getPosition(event);
	                if (_this.dragging) {
	                    if (_this.options.onDragMove) {
	                        _this.options.onDragMove(event, _this.generateDragInformation(last));
	                    }
	                }
	                else {
	                    if (manhattanDistance(_this.start, _this.current) >= _this.getThreshold()) {
	                        _this.dragging = true;
	                        if (_this.options.onDragStart) {
	                            _this.options.onDragStart(event, _this.generateDragInformation(last));
	                        }
	                    }
	                }
	            }
	        });
	        this.handleUp = function (event) {
	            if (_this.down || _this.dragging) {
	                document.body.classList.remove('react-managed-draggable-unselectable');
	                document.removeEventListener('mousemove', _this.handleMove);
	                document.removeEventListener('touchmove', _this.handleMove);
	                document.removeEventListener('mouseup', _this.handleUp);
	                document.removeEventListener('touchend', _this.handleUp);
	                if (_this.dragging) {
	                    _this.dragging = false;
	                    var last = _this.current;
	                    // If touch is released, there are no event coordinates
	                    // this.current = getPosition(event);
	                    if (_this.options.onDragEnd) {
	                        _this.options.onDragEnd(event, _this.generateDragInformation(last));
	                    }
	                }
	                else if (_this.down && _this.options.onClick) {
	                    if ('touches' in event || event.button === 0) {
	                        var last = _this.current;
	                        if (!('touches' in event)) {
	                            _this.current = getPosition(event);
	                        }
	                        _this.options.onClick(event, _this.generateDragInformation(last));
	                    }
	                }
	                _this.down = false;
	            }
	        };
	        this.element = element;
	        this.options = options;
	        this.immediate = !!immediate;
	        if (immediate) {
	            this.dragging = true;
	            document.addEventListener('mousemove', this.handleMove);
	            document.addEventListener('touchmove', this.handleMove);
	            document.addEventListener('mouseup', this.handleUp);
	            document.addEventListener('touchend', this.handleUp);
	        }
	        else {
	            element.addEventListener('mousedown', this.handleDown);
	            element.addEventListener('touchstart', this.handleDown);
	        }
	    }
	    ElementDraggable.prototype.destroy = function () {
	        if (!this.immediate) {
	            this.element.removeEventListener('mousedown', this.handleDown);
	            this.element.removeEventListener('touchstart', this.handleDown);
	        }
	        if (this.down) {
	            this.down = false;
	            if (this.options.onDragEnd) {
	                this.options.onDragEnd(undefined, this.generateDragInformation(this.current));
	            }
	            document.removeEventListener('mousemove', this.handleMove);
	            document.removeEventListener('touchmove', this.handleMove);
	            document.removeEventListener('mouseup', this.handleUp);
	            document.removeEventListener('touchend', this.handleUp);
	        }
	        if (this.down || this.dragging) {
	            document.body.classList.remove('react-managed-draggable-unselectable');
	        }
	    };
	    ElementDraggable.prototype.getThreshold = function () {
	        return this.options.threshold === undefined ? 0 : this.options.threshold;
	    };
	    ElementDraggable.prototype.generateDragInformation = function (last) {
	        return {
	            current: this.current,
	            start: this.start,
	            last: last
	        };
	    };
	    return ElementDraggable;
	}());
	exports.ElementDraggable = ElementDraggable;
	var Draggable = /** @class */ (function (_super) {
	    __extends(Draggable, _super);
	    function Draggable() {
	        var _this = _super !== null && _super.apply(this, arguments) || this;
	        _this.element = null;
	        _this.draggable = null;
	        return _this;
	    }
	    Draggable.prototype.componentDidMount = function () {
	        if (this.element !== null) {
	            this.draggable = new ElementDraggable(this.element, {
	                threshold: this.props.threshold,
	                onDragStart: this.props.onDragStart,
	                onDragMove: this.props.onDragMove,
	                onDragEnd: this.props.onDragEnd,
	                onClick: this.props.onClick
	            });
	        }
	    };
	    Draggable.prototype.componentWillUnmount = function () {
	        if (this.draggable !== null) {
	            this.draggable.destroy();
	            this.draggable = null;
	        }
	    };
	    Draggable.prototype.render = function () {
	        var _this = this;
	        var _a = this.props, children = _a.children, threshold = _a.threshold, onDragStart = _a.onDragStart, onDragMove = _a.onDragMove, onDragEnd = _a.onDragEnd, onClick = _a.onClick, other = __rest(_a, ["children", "threshold", "onDragStart", "onDragMove", "onDragEnd", "onClick"]);
	        return react.createElement("div", __assign({ ref: function (ref) { return _this.element = ref; } }, other), children);
	    };
	    return Draggable;
	}(react.Component));
	exports.Draggable = Draggable;

	});

	var index = unwrapExports(es5);
	var es5_1 = es5.getPosition;
	var es5_2 = es5.ElementDraggable;
	var es5_3 = es5.Draggable;

	exports.default = index;
	exports.getPosition = es5_1;
	exports.ElementDraggable = es5_2;
	exports.Draggable = es5_3;

	Object.defineProperty(exports, '__esModule', { value: true });

})));
