import * as React from 'react';
export interface XY {
    x: number;
    y: number;
}
export declare function getPosition(event: MouseEvent | TouchEvent): XY;
export interface DragInformation {
    current: XY;
    start: XY;
    last: XY;
}
export interface DragOptions {
    threshold?: number;
    onDragStart?: (event: MouseEvent | TouchEvent, dragPayload: DragInformation) => void;
    onDragMove?: (event: MouseEvent | TouchEvent, dragPayload: DragInformation) => void;
    onDragEnd?: (event: MouseEvent | TouchEvent | undefined, dragPayload: DragInformation) => void;
    onClick?: (event: MouseEvent | TouchEvent, dragPayload: DragInformation) => void;
}
export declare class ElementDraggable {
    private element;
    private options;
    private immediate;
    private down;
    private dragging;
    private start;
    private current;
    constructor(element: HTMLElement | SVGElement, options: DragOptions, immediate?: boolean);
    destroy(): void;
    private getThreshold;
    private handleDown;
    private handleMove;
    private handleUp;
    private generateDragInformation;
}
export interface Props extends Pick<React.AllHTMLAttributes<HTMLDivElement>, Exclude<keyof React.AllHTMLAttributes<HTMLDivElement>, keyof DragOptions>>, DragOptions {
}
export declare class Draggable extends React.Component<Props, never> {
    private element;
    private draggable;
    componentDidMount(): void;
    componentWillUnmount(): void;
    render(): JSX.Element;
}
